#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_dJIK48x48x48NN0x0x0_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=N, MB=48, NB=48, KB=48, 
 * lda=0, ldb=0, ldc=0, mu=8, nu=2, ku=4, pf=513
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   const double *stM = A + 48;
   const double *stN = B + (((ldb) << 5)+((ldb) << 4));
   const double *pfA = A + lda*M;
   const int incAk = (lda);
   const int incAm = 8 - (((lda) << 5)+((lda) << 4)), incAn = -48;
   #define incBk 4
   const int incBm = -48, incBn = (((ldb) << 1));
   #define incCm 8
   const int incCn = (((ldc) << 1)) - 48;
   double *pC0=C, *pC1=pC0+(ldc);
   const double *pA0=A;
   const double *pB0=B, *pB1=pB0+(ldb);
   register int k;
   register double rA0, rA1, rA2, rA3, rA4, rA5, rA6, rA7;
   register double rB0, rB1;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC6_0, rC7_0, rC0_1, rC1_1, rC2_1, rC3_1, rC4_1, rC5_1, rC6_1, rC7_1;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+32);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         rC1_0 = pC0[1];
         rC1_0 *= rA0;
         rC2_0 = pC0[2];
         rC2_0 *= rA0;
         rC3_0 = pC0[3];
         rC3_0 *= rA0;
         rC4_0 = pC0[4];
         rC4_0 *= rA0;
         rC5_0 = pC0[5];
         rC5_0 *= rA0;
         rC6_0 = pC0[6];
         rC6_0 *= rA0;
         rC7_0 = pC0[7];
         rC7_0 *= rA0;
         rC0_1 = *pC1;
         rC0_1 *= rA0;
         rC1_1 = pC1[1];
         rC1_1 *= rA0;
         rC2_1 = pC1[2];
         rC2_1 *= rA0;
         rC3_1 = pC1[3];
         rC3_1 *= rA0;
         rC4_1 = pC1[4];
         rC4_1 *= rA0;
         rC5_1 = pC1[5];
         rC5_1 *= rA0;
         rC6_1 = pC1[6];
         rC6_1 *= rA0;
         rC7_1 = pC1[7];
         rC7_1 *= rA0;
         for (k=48; k; k -= 4) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rC0_0 += rA0 * rB0;
            rB1 = *pB1;
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC7_0 += rA7 * rB0;
            rC0_1 += rA0 * rB1;
            rC1_1 += rA1 * rB1;
            rC2_1 += rA2 * rB1;
            rC3_1 += rA3 * rB1;
            rC4_1 += rA4 * rB1;
            rC5_1 += rA5 * rB1;
            rC6_1 += rA6 * rB1;
            rC7_1 += rA7 * rB1;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[1];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rC0_0 += rA0 * rB0;
            rB1 = pB1[1];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC7_0 += rA7 * rB0;
            rC0_1 += rA0 * rB1;
            rC1_1 += rA1 * rB1;
            rC2_1 += rA2 * rB1;
            rC3_1 += rA3 * rB1;
            rC4_1 += rA4 * rB1;
            rC5_1 += rA5 * rB1;
            rC6_1 += rA6 * rB1;
            rC7_1 += rA7 * rB1;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[2];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rC0_0 += rA0 * rB0;
            rB1 = pB1[2];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC7_0 += rA7 * rB0;
            rC0_1 += rA0 * rB1;
            rC1_1 += rA1 * rB1;
            rC2_1 += rA2 * rB1;
            rC3_1 += rA3 * rB1;
            rC4_1 += rA4 * rB1;
            rC5_1 += rA5 * rB1;
            rC6_1 += rA6 * rB1;
            rC7_1 += rA7 * rB1;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[3];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rC0_0 += rA0 * rB0;
            rB1 = pB1[3];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC7_0 += rA7 * rB0;
            rC0_1 += rA0 * rB1;
            rC1_1 += rA1 * rB1;
            rC2_1 += rA2 * rB1;
            rC3_1 += rA3 * rB1;
            rC4_1 += rA4 * rB1;
            rC5_1 += rA5 * rB1;
            rC6_1 += rA6 * rB1;
            rC7_1 += rA7 * rB1;
            pA0 += incAk;
            pB0 += incBk;
            pB1 += incBk;
         }
         pA0 -= 0*incAk;
         *pC0 = rC0_0;
         pC0[1] = rC1_0;
         pC0[2] = rC2_0;
         pC0[3] = rC3_0;
         pC0[4] = rC4_0;
         pC0[5] = rC5_0;
         pC0[6] = rC6_0;
         pC0[7] = rC7_0;
         *pC1 = rC0_1;
         pC1[1] = rC1_1;
         pC1[2] = rC2_1;
         pC1[3] = rC3_1;
         pC1[4] = rC4_1;
         pC1[5] = rC5_1;
         pC1[6] = rC6_1;
         pC1[7] = rC7_1;
         pC0 += incCm;
         pC1 += incCm;
         pA0 += incAm;
         pB0 += incBm;
         pB1 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pA0 += incAn;
      pB0 += incBn;
      pB1 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
